=== debian/changelog ===
libpappsomspp (0.8.15-1) unstable; urgency=low

  * New upstream version depending on libodsstream 0.7.11.

  * Disable make test for the moment.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Dec 2020 18:05:07 +0100

libpappsomspp (0.8.14-1~buster+1) buster; urgency=medium

  * catch2 test suite is working
  * fix for standard exception compatibility

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 16 Dec 2020 14:00:13 +0100

libpappsomspp (0.8.13-1~buster+1) buster; urgency=medium

  * buster package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 09 Dec 2020 15:36:32 +0100

libpappsomspp (0.8.13-1) unstable; urgency=low

  * New upstream with improvement in the XIC widgets.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 08 Dec 2020 16:29:03 +0100

libpappsomspp (0.8.12-1) UNRELEASED; urgency=low

  * New upstream version with new tests imported from mineXpert2
    (Catch2-based).

  * See below for changes between 0.8.8 and now.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 02 Dec 2020 14:28:10 +0100

libpappsomspp (0.8.11-1~buster+1) buster; urgency=medium

  * test added
  * bug fix in chargeDeconvolution filter
  * including catch2 framework

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 24 Nov 2020 10:08:59 +0100

libpappsomspp (0.8.10-1~buster+1) buster; urgency=medium

  * better tandemrun wrapper
  * better FilterSuiteString

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 18 Nov 2020 10:13:20 +0100

libpappsomspp (0.8.9-1~buster+1) buster; urgency=medium

  * rewritten TimsTOF mz calibration API
  * new FilterNameInterface to build Filter with strings
  * Thomas Renne added in the copyright debian notice

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 17 Nov 2020 13:31:57 +0100

libpappsomspp (0.8.8-1~buster+1) buster; urgency=medium

  * autoremove directory created for tandem run wrapper

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 02 Nov 2020 10:50:32 +0100

libpappsomspp (0.8.8-1) unstable; urgency=low

  * Add the possibility to recalculate the x,y,z axis scale to log10 or
    linear.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 21 Oct 2020 14:29:32 +0200

libpappsomspp (0.8.7-1~buster+1) buster; urgency=medium

  * make new builtin centroid interface available throught
    TimsMsRunReader
  * access to the underlying timdata pointer from TimsMsRunReader

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 15 Oct 2020 09:14:24 +0200

libpappsomspp (0.8.6-1~buster+1) buster; urgency=medium

  * builtin centroid for timsdata

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 14 Oct 2020 10:22:37 +0200

libpappsomspp (0.8.5-1~buster+1) buster; urgency=medium

  * more checks on file permissions for tandem run wrapper
  * charge deconvolution documented

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 09 Oct 2020 15:37:09 +0200

libpappsomspp (0.8.4-1~buster+1) buster; urgency=medium

  * new charge deconvolution filter

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 08 Oct 2020 10:52:40 +0200

libpappsomspp (0.8.3-1~buster+1) buster; urgency=medium

  * better msrunreader error messages
  * regorganised xic extractor to ensure that device is released

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 05 Oct 2020 10:19:53 +0200

libpappsomspp (0.8.2-1) buster; urgency=low

  [ Filippo Rusconi ]
  * Fixes in the minus combiners.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 23 Sep 2020 15:22:50 +0200

libpappsomspp (0.8.2-1~buster+1) buster; urgency=medium

  * msrunreader new api to release/acquire file pointers

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 25 Sep 2020 15:07:16 +0200

libpappsomspp (0.8.1-1) unstable; urgency=low

  * Fix bug due to not testing pointer against nullptr.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Sep 2020 17:20:31 +0200

libpappsomspp (0.8.0-1) UNRELEASED; urgency=low

  * Add MSn support.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Sep 2020 15:53:13 +0200

libpappsomspp (0.7.15-1) unstable; urgency=low

  * Attempt at fixing the test/test_massrange.cpp failure in i386 platforms.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 10 Sep 2020 18:07:48 +0200

libpappsomspp (0.7.14-1) unstable; urgency=low

  * Bug fix in DataPoint initialization using initialize().

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 02 Sep 2020 10:23:48 +0200

libpappsomspp (0.7.14-1~buster+1) buster; urgency=medium

  * new filters : FilterComplementIonEnhancer, FilterGreatestYperWindow,
    FilterRemoveC13

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 27 Aug 2020 10:36:53 +0200
